	'
	' Rain
	' Demo for IntyBASIC
	' by Oscar Toledo G. http://nanochess.org/
	' Apr/10/2017
	' Jan/09/2018 Added more comments and tree animation
	'
	
	DIM x_tree(8)

	'
	' It uses the Color Stack mode because it allows fast change of the
	' background color just by changing the parameters to MODE 0
	'
	MODE 0,1,1,1,1
	CLS
	DEFINE 0,8,rain_0_0
	DEFINE ALTERNATE 8,4,palm_tree_0
	WAIT

	'
	' Fill the screen with rain
	' 
	FOR c = 0 TO 19
	GOSUB draw_column
	NEXT c

	'
	' Draw palm trees in background (note priority bit in third arg)
	'
	FOR c = 0 TO 7
		x_tree(c) = c * 20 + RANDOM(8)
		SPRITE c,$0708 + x_tree(c),$0288 + RANDOM(20) + 50,$2804+8*8
	NEXT c

	'
	' Main loop
	'
main_loop:
	WAIT
	WAIT
	DEFINE 0,8,rain_0_0	' Move rain (offset = 0px)
	IF lightning = 1 THEN MODE 0,0,0,0,0	' Black background
	WAIT
	WAIT
	DEFINE 0,8,rain_0_1	' Move rain (offset = 8px)
	IF lightning = 1 THEN MODE 0,7,7,7,7	' White background
	WAIT
	WAIT
	DEFINE 0,8,rain_0_2	' Move rain (offset = 16px)
	WAIT
	WAIT
	DEFINE 0,8,rain_0_3	' Move rain (offset = 24px)

	c = RANDOM(20)
	GOSUB draw_column	' Change a rain column

	IF lightning = 1 THEN MODE 0,1,1,1,1:lightning = 0	 ' Normal background

	' Check if it should start a lightning
	IF RAND = 0 THEN MODE 0,7,7,7,7:lightning=1	' White background

	IF RAND AND 64 THEN
		FOR c = 0 TO 7
			SPRITE c,$0708 + x_tree(c),,$2804+8*8
		NEXT c
	ELSE
		FOR c = 0 TO 7
			SPRITE c,$0708 + x_tree(c) + 2,,$2804+10*8
		NEXT c
	END IF

	GOTO main_loop

	'
	' Draw a column of rain
	'
draw_column:	PROCEDURE
	g = RANDOM($1F)		' Generate two numbers in one call
	d = g % 12 * 20 + c	' First one is random start row (1 in 4)
	f = ((g / 16) AND 1) * 24	' Select one of two columns bitmaps

	' After drawing the last row of screen goes back to first row
	FOR e = 0 TO 2
		PRINT AT d,$1800+f
		IF d >= 220 THEN d = d - 220 ELSE d = d + 20
		PRINT AT d,$1808+f
		IF d >= 220 THEN d = d - 220 ELSE d = d + 20
		PRINT AT d,$1810+f
		IF d >= 220 THEN d = d - 220 ELSE d = d + 20
		PRINT AT d,$1818+f
		IF d >= 220 THEN d = d - 220 ELSE d = d + 20
	NEXT e
	END

rain_0_0:
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"

	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

rain_0_1:
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"

	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

rain_0_2:
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"

	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

rain_0_3:
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"
	BITMAP "10000000"

	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"
	BITMAP "00001000"

palm_tree_0:
	BITMAP "01100000"
	BITMAP "00100100"
	BITMAP "10101100"
	BITMAP "11111011"
	BITMAP "10111111"
	BITMAP "10101110"
	BITMAP "01101011"
	BITMAP "01001000"
	BITMAP "00011000"
	BITMAP "00011000"
	BITMAP "00011100"
	BITMAP "00011100"
	BITMAP "00111000"
	BITMAP "00111000"
	BITMAP "00111000"
	BITMAP "00011100"

palm_tree_1:
	BITMAP "01100000"
	BITMAP "00100100"
	BITMAP "10101100"
	BITMAP "11111011"
	BITMAP "10111111"
	BITMAP "10101110"
	BITMAP "01101011"
	BITMAP "01001000"
	BITMAP "00110000"
	BITMAP "00110000"
	BITMAP "00111000"
	BITMAP "00111000"
	BITMAP "01110000"
	BITMAP "01110000"
	BITMAP "01110000"
	BITMAP "00111000"

